﻿//                             ___           ___         ___     
//  Feel free to use and      /\  \         /\  \       /\__\    
//  modify any of this code   \:\  \       /::\  \     /:/  /    
//                             \:\  \     /:/\:\__\   /:/  /     
//   ________  ________    _____\:\  \   /:/ /:/  /  /:/  /  ___ 
//  |\   __  \|\   __  \  /::::::::\__\ /:/_/:/  /  /:/__/  /\__\
//  \ \  \|\  \ \  \|\  \ \:\~~\~~\/__/ \:\/:/  /   \:\  \ /:/  /
//   \ \   ____\ \   ____\ \:\  \        \::/__/     \:\  /:/  / 
//    \ \  \___|\ \  \___|  \:\  \        \:\  \      \:\/:/  /  
//     \ \__\    \ \__\      \:\__\        \:\__\      \::/  /   
//      \|__|     \|__|       \/__/         \/__/       \/__/     
//
//
using UnityEngine;
using UnityEngine.Events;
using System.Linq;
using System.Collections.Generic;
using System.Collections;

namespace PPnpc
{
	public class NpcGadget : MonoBehaviour
	{
		public Gadgets Gadget;
		public LightSprite[] Lights;
		public Coroutine AnimateRoutine;
		public bool BeenActivated = false;
		public PersonBehaviour TargetPerson;
		public float Timer1;
		public float Timer2;
		public float[] MiscFloats;
		public string[] MiscStrings;
		public bool[] MiscBools;
		public Transform TargetTrans;
		public SpriteRenderer[] SRS;
		public AudioClip[] AudioClips;
		public Color[] MiscColors;
		private AudioSource audioSource;
		private int _teamId = 0;
		private bool AlreadyAI = false;
		public Dictionary<string, Rigidbody2D>   RB  = new Dictionary<string, Rigidbody2D>();
		public Dictionary<string, LimbBehaviour> LB  = new Dictionary<string, LimbBehaviour>();
		public float Facing;
		public GameObject AIgo;
		public GameObject MiscGameObject;
		public PhysicalBehaviour PB;
		public GameObject TextObj;
        public TextMesh TextM;
		public Coroutine xCoroutine;
		public NpcGadget Expansion;
		public List<NpcBehaviour> NpcQueue;
		public bool WorkingQueue = false;
		public Coroutine QueueRoutine = null;
		private bool _rebirtherActive = false;
		public SpawnableAsset asset;
		public SingleFloodlightBehaviour[] Lightsx;

		public bool RebirtherActive
        {
			get { return _rebirtherActive; }
			set { 
				if ( value != _rebirtherActive )
                {
					if (!value )
                    {
						if (QueueRoutine != null) StopCoroutine(QueueRoutine);
						foreach ( NpcBehaviour npc in NpcQueue )
                        {
							if ( npc )
                            {
								GameObject.Destroy(npc.RebirthLight.gameObject);
								npc.RunLimbs(npc.LimbAlphaFull,true);
								npc.RunLimbs(npc.LimbGhost, false);
								npc.RunLimbs(npc.LimbImmune, false);
								npc.RunLimbs(npc.LimbIchi);
								NpcDeath reaper = npc.PBO.gameObject.AddComponent<NpcDeath>();
								reaper.Config(npc);
                            }
                        }
						NpcQueue.Clear();
                    } else
                    {
						_rebirtherActive = value; 
						QueueRoutine = StartCoroutine(IProcessQueue());
                    }
                }
				_rebirtherActive = value; 
				
			}
        }

		IEnumerator IProcessQueue()
        {
			//asset = ModAPI.FindSpawnable("Flashlight");

   //         GameObject instance    = UnityEngine.Object.Instantiate<GameObject>(asset.Prefab, transform.position, Quaternion.identity) as GameObject;
   //         PhysicalBehaviour pb   = instance.GetComponent<PhysicalBehaviour>();

   //         pb.SpawnSpawnParticles                    = false;
			//pb.Disintegratable                        = false;
   //         pb.SimulateTemperature                    = false;
   //         pb.StabCausesWound                        = false;
   //         pb.Properties.Brittleness                 = 0.0001f;
   //         pb.Properties.BurningTemperatureThreshold = float.MaxValue;
   //         pb.Properties.Burnrate                    = 0.00001f;
   //         pb.Properties.Conducting                  = false;
   //         pb.Properties.Flammability                = 0.0000001f;
   //         pb.Properties.BulletSpeedAbsorptionPower  = float.MaxValue;

   //         instance.layer = 2;

   //         instance.transform.SetParent(gameObject.transform, false);
   //         instance.transform.position        = transform.position;
			//instance.transform.localPosition   = new Vector3(0,1.5f);
			////instance.transform.localScale = new Vector3(10f,1f);

			////instance.layer = LayerMask.NameToLayer("Debris"); 
			////pb.gameObject.layer = instance.layer;

			//FixedJoint2D joint                 = instance.gameObject.AddComponent<FixedJoint2D>();
			//joint.connectedBody                = PB.rigidbody;
			//joint.autoConfigureConnectedAnchor = true;

   //         Lightsx = new SingleFloodlightBehaviour[2];

			////instance.transform.localPosition = spotLight.Offset;
   //         //instance.transform.localRotation = Quaternion.Euler(0,0, spotLight.Rotation);

   //         if (instance.TryGetComponent<SpriteRenderer>(out SpriteRenderer srr))
   //         {
   //             Texture2D tex    = new Texture2D(0, 0);
   //             Sprite mySprite  = Sprite.Create(tex, new Rect(0.0f, 0.0f, tex.width, tex.height), new Vector2(0.1f, 0.1f), 0.1f);
   //             srr.sprite       = mySprite;
   //         }
            

			//Lightsx[0] = instance.GetComponent<SingleFloodlightBehaviour>();
			//Lightsx[0].transform.localScale = new Vector3(10f, 0.5f);
   //         Lightsx[0].Highlights[0].Intensity = 0f;
   //         Lightsx[0].Highlights[0].Colour = Color.red;
   //         Lightsx[0].Highlights[0].Initialise();
			//Lightsx[0].Activated = true;

   //         if (Lightsx[0].TryGetComponent<DamagableMachineryBehaviour>(out DamagableMachineryBehaviour dmb))
   //         {
   //             GameObject.Destroy(dmb);
   //         }

			float cpuSpeedStart = 10;
			float cpuSpeed;
			float ww;
			Vector2 dist;
			NpcBehaviour npc = null;
			while ( RebirtherActive )
            {
				ww = 1;
				cpuSpeed = Mathf.Clamp(cpuSpeedStart - (PB.charge * 0.1f), 1, 10);
				yield return new WaitForSeconds(cpuSpeed);

				if ( NpcQueue.Count <= 0 ) continue;
				//Lightsx[0].Highlights[0].Colour = Color.red;
				//Lightsx[0].transform.localScale = new Vector3(, 0.5f);

				npc = NpcQueue[0];

				NpcQueue.RemoveAt(0);

				if (!npc) continue;

				npc.InRebirth = false;

				float sqr;

				while (npc && npc.PBO)
                {
					dist = (transform.position - npc.Head.position);
					sqr  = dist.sqrMagnitude;
                    npc.RB["UpperBody"].AddForce(dist.normalized * 30f * Time.fixedDeltaTime);
					if ( sqr < 2000f )
                    {
						//Lightsx[0].Highlights[0].Intensity = 1f;
						//Lightsx[0].transform.localScale = new Vector3(sqr/200f, 0.5f);
                    }
					if ( sqr < 5f )
                    {
						npc.RB["UpperBody"].velocity = Vector2.zero;
						break;
                    }
					yield return new WaitForFixedUpdate();
                }

				if (!npc) continue;

                npc.RB["UpperBody"].velocity = Vector2.zero;

				xxx.ToggleCollisions(npc.Head, transform);
				
				yield return new WaitForFixedUpdate();

				npc.RunLimbs(npc.LimbRecover);
				npc.RunLimbs(npc.LimbHeal);

                npc.LB["Foot"].PhysicalBehaviour.MakeWeightful();
				//npc.LB["FootFront"].PhysicalBehaviour.MakeWeightful();

				float timer = Time.time + 1.5f;
				//Lightsx[0].Highlights[0].Colour = Color.green;
				while ( Time.time < timer )
                {
					ww += 0.05f;
					//Lightsx[0].transform.localScale = new Vector3(Mathf.Clamp(ww,1,10), 0.5f);
					dist = (transform.position - npc.Head.position);
					npc.RB["Head"].AddForce(dist.normalized * 10f * Time.fixedDeltaTime);
                    npc.RB["UpperBody"].velocity *= 0.01f;
					yield return new WaitForFixedUpdate();
                }

				StartCoroutine(IMessage("You have been\nRebirthed!", 20));

				for (int i = 1; ++i < 50;) 
				{
					dist = (transform.position - npc.Head.position);
					//npc.RB["Head"].AddForce(dist.normalized * 3f * Time.fixedDeltaTime);
                    npc.RB["UpperBody"].velocity *= 0f;
					npc.RunLimbs(npc.LimbAlphaDelta,0.05f);
					yield return new WaitForFixedUpdate();
					yield return new WaitForSeconds(0.05f);

					if (Time.frameCount % 1 == 0)
                    {
						LimbBehaviour limb = npc.PBO.Limbs.PickRandom();
						ModAPI.CreateParticleEffect("Flash", limb.transform.position);
                    }
				}

				npc.RunLimbs(npc.LimbGhost, false);
				npc.RunLimbs(npc.LimbAlphaFull,true);
				npc.RunLimbs(npc.LimbImmune, false);
				
				GameObject.Destroy(npc.RebirthLight.gameObject);

				StartCoroutine(IMessage("Better luck\nthis time!", 24));

				npc.Reborn();
                
				//Lightsx[0].Highlights[0].Intensity = 0f;
				//Lightsx[0].Highlights[0].Colour = Color.red;



            }


			yield break;
        }

		public int TeamId { 
			get { 
				return Mathf.Clamp(_teamId, 0, NpcGlobal.MaxTeamId); 
				} 
			set { 
				if (value > NpcGlobal.MaxTeamId) value = 0; 
				_teamId = value;
				if (_teamId > 0)
				{
					string teamColor = xxx.GetTeamColor(_teamId);
					
					if ( Gadget == Gadgets.AIChip )
                    {
						if (ColorUtility.TryParseHtmlString(teamColor + "FF", out Color color))  MiscColors[0] = color;
						if (ColorUtility.TryParseHtmlString(teamColor + "99", out Color color2)) MiscColors[1] = color2;
					}
					else if (Gadget == Gadgets.Rebirther )
                    {
						string hexalpha = Mathf.RoundToInt(Mathf.Clamp(PB.charge * 2, 25, 255)).ToString("X2");
						if (ColorUtility.TryParseHtmlString(teamColor + hexalpha, out Color color))  MiscColors[0] = color;
						hexalpha = Mathf.RoundToInt(Mathf.Clamp(PB.charge , 15, 125)).ToString("X2");
						if (ColorUtility.TryParseHtmlString(teamColor + hexalpha, out Color color2)) MiscColors[1] = color2;
                    }

					xxx.CheckRebirthers();

				}
			} 
		}

		public void Init( Gadgets _gadget )
		{
			Gadget = _gadget;

			switch ( Gadget )
			{
				case Gadgets.AIChip:
					SetupAIChip();
					break;

				case Gadgets.Rebirther:
					SetupRebirther();
					break;

				case Gadgets.Expansion:
					SetupExpansion();
					break;
			}
		}

		public void Shot(Shot shot)
		{
			
			Damaged();
		}
		

		public void Damaged()
		{
			if ( Gadget == Gadgets.AIChip ) { 
				List<Collider2D> colliders = new List<Collider2D>();
				ModAPI.CreateParticleEffect("IonExplosion", transform.position);
				Physics2D.OverlapBox(transform.position, new Vector2(10,5),0f, new ContactFilter2D(), colliders);
				foreach ( Collider2D collider in colliders )
				{
					if ( collider.gameObject.TryGetComponent<PhysicalBehaviour>( out PhysicalBehaviour phys ) )
					{
						phys.SendMessage("OnEMPHit", SendMessageOptions.DontRequireReceiver);
					}
				}
				GameObject.Destroy(this.gameObject);
			}
		}

		public void Use(ActivationPropagation activation)
		{
			
			if ( Gadget == Gadgets.AIChip )
            {
				audioSource.PlayOneShot(AudioClips[0], 2f);
				TeamId += 1;
				string teamColor = xxx.GetTeamColor(TeamId);
				MiscStrings[0] = teamColor;
				MiscStrings[1] = teamColor;
			}


			if ( Gadget == Gadgets.Rebirther )
            {
				if (xCoroutine != null) StopCoroutine(xCoroutine);

				if (PB.charge < 1f) xCoroutine = StartCoroutine(INoPower());
				else
                {
					audioSource.PlayOneShot(AudioClips[0], 2f);
					TeamId += 1;
					string teamColor = xxx.GetTeamColor(TeamId);
					MiscStrings[0] = teamColor;
					MiscStrings[1] = teamColor;
                }
            }
		}


		void Awake()
		{
			audioSource              = gameObject.AddComponent<AudioSource>();
			audioSource.spread       = 35f;
			audioSource.volume       = 1f;
			audioSource.minDistance  = 15f;
			audioSource.spatialBlend = 1f;
			audioSource.dopplerLevel = 0f;
		}

		

		public void SetupExpansion()
        {
			MiscBools = new bool[] {false, false};
        }

		public void SetupRebirther()
        {
			PB          = gameObject.GetComponent<PhysicalBehaviour>();
			MiscBools   = new bool[] { false, false };
			MiscStrings = new string[] {"000000", "000000"};
			MiscColors  = new Color[] { Color.red, Color.green, Color.blue };
			MiscFloats  = new float[]{ Time.time, 0.01f };
			TextObj     = new GameObject("SignText") as GameObject;

            TextObj.transform.SetParent(transform, false);
            TextObj.transform.parent   = transform;
            TextObj.transform.position = transform.position;

            TextObj.SetActive(true);

            TextM = TextObj.GetOrAddComponent<TextMesh>() as TextMesh;

            SpriteRenderer sr   = gameObject.GetComponent<SpriteRenderer>();
            MeshRenderer mr     = TextM.GetComponent<MeshRenderer>();
            mr.sortingLayerName = sr.sortingLayerName;
            mr.sortingOrder     = sr.sortingOrder + 1;

            TextM.transform.SetParent(transform, false);

            TextM.fontStyle = FontStyle.Normal;
            TextM.color     = Color.blue;
            TextM.anchor    = TextAnchor.UpperLeft;

            TextM.transform.localScale    = new Vector3(0.05f, 0.05f, 0.0f);
            TextM.transform.localPosition = new Vector3(-0.3f, 0.65f);
			TextM.alignment               = TextAlignment.Center;
			TextM.fontSize                = 18;

			NpcQueue = new List<NpcBehaviour>();

			


			//asset       = ModAPI.FindSpawnable("Red cathode light");
   //         instance	= UnityEngine.Object.Instantiate<GameObject>(asset.Prefab, transform.position, Quaternion.identity) as GameObject;
            
			//pb	= instance.GetComponent<PhysicalBehaviour>();
   //         pb.SpawnSpawnParticles                    = false;
			//pb.Disintegratable                        = false;
   //         pb.SimulateTemperature                    = false;
   //         pb.StabCausesWound                        = false;
   //         pb.Properties.Brittleness                 = 0.0001f;
   //         pb.Properties.BurningTemperatureThreshold = float.MaxValue;
   //         pb.Properties.Burnrate                    = 0.00001f;
   //         pb.Properties.Conducting                  = false;
   //         pb.Properties.Flammability                = 0.0000001f;
   //         pb.Properties.BulletSpeedAbsorptionPower  = float.MaxValue;

   //         instance.layer = 2;

   //         instance.transform.SetParent(gameObject.transform, false);
   //         instance.transform.position        = transform.position;
			//instance.transform.localPosition   = new Vector3(0,-1.5f);

			////instance.transform.localRotation	= new Quaternion(0,45,0,0);

			////instance.layer = LayerMask.NameToLayer("Debris"); 
			////pb.gameObject.layer = instance.layer;

			//FixedJoint2D joint2                 = instance.gameObject.AddComponent<FixedJoint2D>();
			//joint2.connectedBody                = PB.rigidbody;
			//joint2.autoConfigureConnectedAnchor = true;


			////instance.transform.localPosition = spotLight.Offset;
   //         //instance.transform.localRotation = Quaternion.Euler(0,0, spotLight.Rotation);

   //         if (instance.TryGetComponent<SpriteRenderer>(out SpriteRenderer srr2))
   //         {
   //             Texture2D tex     = new Texture2D(0, 0);
   //             Sprite mySprite   = Sprite.Create(tex, new Rect(0.0f, 0.0f, tex.width, tex.height), new Vector2(0.1f, 0.1f), 0.1f);
   //             srr2.sprite       = mySprite;
   //         }
            
   //         if (instance.TryGetComponent<GlowtubeBehaviour>(out GlowtubeBehaviour tube))
   //         {
   //             tube.Activated         = true;
   //             tube.LightSprite.color = Color.red;
			//	tube.GasColour         = Color.blue;
			//	tube.GasEffectRadius   = 5f;

   //             if (light.TryGetComponent<DamagableMachineryBehaviour>(out DamagableMachineryBehaviour dmb))
   //             {
   //                 GameObject.Destroy(dmb);
   //             }

			//}

			//GlowtubeBehaviour

			AnimateRoutine = StartCoroutine(IAnimateRebirther());
        }

		public IEnumerator INoPower()
        {
			TextM.transform.localPosition = new Vector3(-0.3f, 0.65f);
			TextM.alignment               = TextAlignment.Center;
			TextM.fontSize                = 18;
			TextM.color                   = Color.blue;
			
			for ( int i = 0; ++i <= 10; )
            {
				TextM.text = "No Power";
				yield return new WaitForSeconds(0.5f);
				TextM.text = "";
				yield return new WaitForSeconds(0.5f);
            }
        }

		public IEnumerator IMessage(string message, int fontSize)
        {
			TextM.transform.localPosition = new Vector3(-0.3f, 0.65f);
			TextM.alignment               = TextAlignment.Center;
			TextM.fontSize                = fontSize;
			TextM.color                   = Color.cyan;
			TextM.text = message;
			yield return new WaitForSeconds(3);

			TextM.text = "";
        }

		public IEnumerator ILogo()
        {
			TextM.transform.localPosition = new Vector3(-0.3f, 0.65f);
			TextM.alignment = TextAlignment.Center;
			TextM.fontSize = 12;
			TextM.color = Color.yellow;
			
			for ( int i = 0; ++i <= 10; )
            {
				TextM.text = "Rebirther\n\n\"Giving dumb AI a 2nd \nchance since 2022!\"";
				yield return new WaitForSeconds(0.5f);
				
            }
			TextM.text = "";
        }
		
		public IEnumerator IAnimateRebirther()
		{
			GameObject bs;
			SpriteRenderer bsr;
			Color c;
			for(;;)
			{
				while ( PB.charge < 1f )
                {
                    SRS[1].color = new Color(0.0f,0.0f,0.0f,0.0f);
                    MiscBools[0] = MiscBools[1] = RebirtherActive = false;
					yield return new WaitForSeconds(2f);
                }

				if ( !MiscBools[0] )
                {
					RebirtherActive = false;
					if (xCoroutine != null) StopCoroutine(xCoroutine);
					TextM.text = "Booting Up...";
					TextM.color = Color.cyan;
					yield return new WaitForSeconds(2f);
					TextM.text = "";

					if ( !Expansion || !Expansion.MiscBools[0] )
                    {
                        MiscBools[0]    = MiscBools[1] = false;
						bs	            = new GameObject() as GameObject;
						bsr				= bs.AddComponent<SpriteRenderer>();
						bsr.sprite      = NpcMain.BlueScreenOfDeath;
						bs.transform.SetParent(transform);
						bs.transform.position      = transform.position;
						bs.transform.rotation      = transform.rotation;
						bs.transform.localPosition = new Vector2(0,0.5f);
						

						while ( PB.charge > 1f )
                        {
							yield return new WaitForFixedUpdate();
                        }

						GameObject.Destroy(bs);
                    } else
                    {
	                    MiscBools[0] = true;
						SRS[1].color = new Color(1.0f,1.0f,1.0f,0.1f);
						TeamId = TeamId;
						MiscFloats[1] = 0.01f;
						StartCoroutine(ILogo());
                    }
                }

				if ( MiscBools[0] )
                {
					if ( !Expansion || !Expansion.MiscBools[0] )
                    {
						RebirtherActive = false;
                        MiscBools[0]    = MiscBools[1] = false;
						bs	            = new GameObject() as GameObject;
						bsr				= bs.AddComponent<SpriteRenderer>();
						bsr.sprite      = NpcMain.BlueScreenOfDeath;
						bs.transform.SetParent(transform);
						bs.transform.position      = transform.position;
						bs.transform.rotation      = transform.rotation;
						bs.transform.localPosition = new Vector2(0,0.5f);
						SRS[1].color = new Color(0.0f,0.0f,0.0f,1f);

						while ( PB.charge > 1f )
                        {
							yield return new WaitForFixedUpdate();
                        }

						GameObject.Destroy(bs);
                    } else
                    {
						RebirtherActive = true;
						if (TeamId == 0) { 
							if ( Time.frameCount % 10 == 0 )
							{
								MiscFloats[1] = Mathf.Clamp(PB.charge * 0.5f, 25.1f, 100) * 0.01f;
							}
							SRS[1].color = Color.HSVToRGB( Mathf.PingPong((Time.time + MiscFloats[0]) * 0.1f, 1), MiscFloats[1] * 2, MiscFloats[1]);

							//Lights[1].Color = Color.HSVToRGB( Mathf.PingPong((Time.time + MiscFloats[0]), 1), 1, 1);
						} else
						{
							SRS[1].color = Color.Lerp(MiscColors[0], MiscColors[1], Mathf.PingPong((Time.time + MiscFloats[0]) , 1));
						}

						if (NpcQueue.Count > 0) {
							c = Color.HSVToRGB( Mathf.PingPong((Time.time + MiscFloats[0]) * 0.1f, 1), 1, 1);
							for(int i = NpcQueue.Count; --i >= 0;) {
								if ( !NpcQueue[i] || !NpcQueue[i].RebirthLight || !NpcQueue[i].RebirthLight.gameObject) continue;
								NpcQueue[i].RebirthLight.Color = c;
							}

                            if ( Time.frameCount % 100 == 0 )
                            {
                                NpcBehaviour npc = NpcQueue.PickRandom();

                                if (npc) npc.RB["UpperBody"].AddForce( UnityEngine.Random.insideUnitCircle * xxx.rr( 1, PB.charge / 3 ), ForceMode2D.Impulse );
                            }

                        }

					}
                }



				
				yield return new WaitForFixedUpdate();
			}
		}

		public void SetupAIChip()
		{
			//	Add fekn lights
			Lights = new LightSprite[2];

			Lights[0]            = ModAPI.CreateLight(transform, Color.Lerp(new Color32(0,0,50,255), new Color32(0,0,255,255),Time.fixedDeltaTime * 100));
			Lights[0].Brightness = 1.5f;
			Lights[0].Radius     = 0.225f;
			Lights[0].transform.SetParent(this.gameObject.transform);

			
			Lights[1]            = ModAPI.CreateLight(transform, Color.Lerp(new Color32(50,0,0,255), new Color32(255,0,0,255),Time.fixedDeltaTime * 100));
			
			Lights[1].Brightness = 0.5f;
			Lights[1].Radius     = 0.225f;
			Lights[1].transform.SetParent(this.gameObject.transform);

			SRS = new SpriteRenderer[2];
			
			GameObject TeamSelect = gameObject.transform.Find("TeamSelect").gameObject;
			SRS[1] = TeamSelect.GetComponent<SpriteRenderer>();



			MiscFloats = new float[]{ Time.time };
			MiscStrings = new string[]
			{
				"000000", "000000"
			};


			MiscColors = new Color[] { Color.red, Color.green, Color.blue };

			PB.ForceNoCharge = false;
			PB.ChargeBurns = true;
			
			AnimateRoutine = StartCoroutine(IAnimateAIChip());

		}

		public IEnumerator IAnimateAIChip()
		{
			Vector3 pos = Vector3.zero;


			for(;;)
			{
				if (PB.charge > 1f ) { Damaged(); }
				if (!BeenActivated) { 
					Lights[0].Radius = 0.225f * Mathf.Cos(Time.frameCount);
					Lights[0].Brightness = 1 + Mathf.Sin(Time.frameCount);
				}
				if (TeamId == 0) { 
					SRS[1].material.SetColor("_Color", Color.HSVToRGB( Mathf.PingPong((Time.time + MiscFloats[0]) * 0.1f, 1), 1, 1));

					Lights[1].Color = Color.HSVToRGB( Mathf.PingPong((Time.time + MiscFloats[0]), 1), 1, 1);
				} else
				{
					SRS[1].material.SetColor("_Color",Color.Lerp(MiscColors[0], MiscColors[1], Mathf.PingPong((Time.time + MiscFloats[0]) , 1)));
				}

				yield return new WaitForEndOfFrame();// WaitForSeconds(0.1f);
				yield return new WaitForFixedUpdate();// WaitForSeconds(0.1f);

				if ( BeenActivated )
				{
					SRS[1].sortingOrder = -1;
					//RB["LowerArm"].AddForce((RB["Head"].position - RB["LowerArm"].position ) * 150f * Time.fixedDeltaTime);
					//RB["LowerArmFront"].AddForce((RB["Head"].position - RB["LowerArmFront"].position ) * 200f * Time.fixedDeltaTime);
					//RB["UpperArm"].AddForce(new Vector2(1,1) * Facing * 150f * Time.fixedDeltaTime);
					//RB["UpperArmFront"].AddForce(new Vector2(1,1) * Facing * 170f * Time.fixedDeltaTime);
					if (!AlreadyAI && TargetPerson.IsTouchingFloor) { 
						RB["UpperBody"].AddForce(new Vector2(0,3) * 170f * Time.fixedDeltaTime);
						TargetPerson.OverridePoseIndex = (int)PoseState.Protective;
					}

					//transform.position -= Vector3.up * Time.fixedDeltaTime * 0.3f;
					transform.position = Vector2.Lerp(transform.position,TargetTrans.position, Time.fixedDeltaTime );
					Lights[0].Color = Lights[1].Color;

					if (AlreadyAI) TargetPerson.OverridePoseIndex = (int)PoseState.WrithingInPain;
					
					pos.x = Mathf.Cos(Time.frameCount);
					pos.y = Mathf.Sin(Time.frameCount);
					float dist1 = AlreadyAI ? xxx.rr(0.1f,1.0f) : 0.23f;
					float dist2 = AlreadyAI ? xxx.rr(0.1f,1.0f) : 0.33f;
					Lights[1].transform.position = transform.position + (pos * dist1); 
					Lights[1].Brightness += Time.fixedDeltaTime * 2;

					pos.y = Mathf.Cos(Time.frameCount);
					pos.x = Mathf.Sin(Time.frameCount);

					Lights[0].transform.position = transform.position + (pos * dist2); 
					Lights[0].Brightness += Time.fixedDeltaTime * 2;

					if (Time.frameCount % 50 == 0) {
						ModAPI.CreateParticleEffect("FuseBlown", transform.position);
						ModAPI.CreateParticleEffect("BloodExplosion", transform.position);
					}

					if ( Time.time > Timer2 && !AlreadyAI ) TargetPerson.OverridePoseIndex = -1;

					if ( Time.time > Timer1 )
					{

						if (Time.time > Timer1 + 2f ) { 

							yield return new WaitForEndOfFrame();

							if(gameObject.TryGetComponent<FixedJoint2D>( out FixedJoint2D joint2D)) {
								GameObject.Destroy(joint2D);
								Lights[0].enabled = Lights[1].enabled = false;
								GameObject.Destroy(Lights[0].gameObject);
								GameObject.Destroy(Lights[1].gameObject);

								gameObject.GetComponent<Renderer>().enabled = false;
								gameObject.transform.localScale = Vector3.zero;
								
								yield return new WaitForFixedUpdate();
							}
							
							if ( AlreadyAI )
							{
								audioSource.PlayOneShot(AudioClips[3], 1f);

								ExplosiveBehaviour explosion = TargetPerson.Limbs[0].gameObject.GetOrAddComponent<ExplosiveBehaviour>();
								explosion.Range              = 5f;
								explosion.ShockwaveStrength  = 1.5f;
								explosion.Delay              = xxx.rr(0.01f,2.0f);
								explosion.FragmentForce      = 2.5f;
								explosion.ShockwaveLiftForce = 1f;
								explosion.BurnPower          = 0f;
								explosion.DismemberChance    = 0.9f;
								explosion.ArmOnAwake         = true;
								explosion.Use(null);
								yield return new WaitForSeconds(3);
								break;
							}

							foreach( LimbBehaviour limbx in TargetPerson.Limbs ) limbx.Broken = false;
							
							bool alreadySet = TargetPerson.gameObject.TryGetComponent<NpcBehaviour>(out _);

							NpcBehaviour npc = TargetPerson.gameObject.GetOrAddComponent<NpcBehaviour>();
							audioSource.PlayOneShot(AudioClips[2], 1f);
							yield return new WaitForSeconds(3);
				
							yield return new WaitForFixedUpdate();
							npc.enabled  = true;
							npc.TeamId   = TeamId;
							npc.AIMethod = AIMethods.AIChip;
							if (alreadySet) npc.StartCoroutine(npc.IGlitch());
							break;
						}
					}
				}
			}
			
			StopAllCoroutines();
			Destroy(this);
			DestroyImmediate(gameObject);

		}


		

		void OnJointBreak2D (Joint2D brokenJoint) {

			if (Gadget == Gadgets.Expansion)
            {
				ModAPI.CreateParticleEffect("Spark", transform.position);
                MiscBools[0] = false;

				xxx.ToggleCollisions(brokenJoint.connectedBody.transform, transform, true);
            }

		}
		

		private void OnCollisionEnter2D(Collision2D coll=null)
		{
			if (Gadget == Gadgets.Rebirther) return;

			if (Gadget == Gadgets.Expansion && coll.gameObject.name == "AI Microchip")
            {
				if (Mathf.Abs(coll.gameObject.transform.rotation.z - transform.rotation.z) < 0.1f &&
					Mathf.Abs(coll.gameObject.transform.position.x - transform.position.x) < 0.05f ) { 
					
					ModAPI.CreateParticleEffect("Spark", transform.position);

					xxx.ToggleCollisions(coll.gameObject.transform, transform,false,true);

					MiscBools[0]=true;

					
					coll.gameObject.transform.position = transform.position + new Vector3(0,0.1f);
					coll.gameObject.transform.rotation = transform.rotation;
					
					FixedJoint2D joint                 = gameObject.AddComponent<FixedJoint2D>();
					joint.connectedBody                = coll.gameObject.GetComponent<Rigidbody2D>();
					joint.autoConfigureConnectedAnchor = true;
					joint.breakForce                   = 1f;

				}
            }

			if (BeenActivated) return;
			if (coll == null || coll.collider == null) return;
			if ( coll.gameObject && coll.transform && coll.transform.root && coll.transform.root.TryGetComponent<PersonBehaviour>( out PersonBehaviour person) )
			{
				

				if ( person.IsAlive() )
				{
					if (coll.gameObject.TryGetComponent<LimbBehaviour>(out LimbBehaviour lb))
					{ 
						if ( lb.RoughClassification == LimbBehaviour.BodyPart.Head )
						{

							PhysicalBehaviour pb = gameObject.GetComponent<PhysicalBehaviour>();
							GripBehaviour[] AllGrips = UnityEngine.Object.FindObjectsOfType<GripBehaviour>();
							for ( int i = AllGrips.Length; --i >= 0; )
                            {
								if(AllGrips[i].isHolding && AllGrips[i].CurrentlyHolding == pb) AllGrips[i].DropObject();
								if ( AllGrips[i].transform.root.TryGetComponent<NpcBehaviour>( out NpcBehaviour holdingNpc ) )
                                {
									holdingNpc.CancelAction = true;
                                }
                            }
							SRS[1].sortingOrder = -1;
							
							gameObject.GetComponent<SpriteRenderer>().sortingOrder     = -1;
							gameObject.GetComponent<SpriteRenderer>().sortingLayerName = lb.PhysicalBehaviour.spriteRenderer.sortingLayerName;
							
							BeenActivated = true;
							transform.SetParent(lb.transform);
							ModAPI.CreateParticleEffect("FuseBlown", transform.position);

							//person.OverridePoseIndex = (int)PoseState.Stumbling;

							//	Already has AI
							if (person.TryGetComponent<NpcBehaviour>( out NpcBehaviour npc)) { 
								AlreadyAI = true;
								npc.DisableFlip = true;
								ModAPI.CreateParticleEffect("HugeZap", transform.position);
								person.OverridePoseIndex = (int)PoseState.WrithingInPain;
							}
							
							audioSource.PlayOneShot(AudioClips[1], 1f);
							
							
							FixedJoint2D joint = gameObject.GetOrAddComponent<FixedJoint2D>();
							
							//joint.anchor                       = lb.transform.InverseTransformPoint(transform.position);
							
							joint.autoConfigureConnectedAnchor = true;
							joint.connectedBody = lb.gameObject.GetOrAddComponent<Rigidbody2D>( );

							gameObject.SetLayer(LayerMask.NameToLayer("Debris"));
							TargetPerson = lb.Person;
							TargetTrans  = lb.transform;
							
							if (TeamId          != 0 && MiscColors[0] != null) Lights[1].Color = Lights[0].Color = MiscColors[0];
							else Lights[1].Color = Lights[0].Color = Color.white;
							Lights[0].Brightness = Lights[1].Brightness = AlreadyAI ? 5.5f : 1.5f;
							Lights[0].Radius     = Lights[1].Radius     = 0.125f;


							Timer1 = Time.time + xxx.rr(1f,3f);
							Timer2 = Time.time + xxx.rr(0.1f,1f);

							Rigidbody2D[] RBs   = TargetPerson.transform.GetComponentsInChildren<Rigidbody2D>();
							LimbBehaviour[] LBs = TargetPerson.transform.GetComponentsInChildren<LimbBehaviour>();
							RB.Clear();
							LB.Clear();
							foreach (Rigidbody2D rb in RBs) RB[rb.name] = rb;
							foreach (LimbBehaviour lbx in LBs) LB[lbx.name] =  lbx;

							//LB["LowerArm"].Broken      = true;
							//LB["LowerArmFront"].Broken = true;

							Facing = TargetPerson.transform.localScale.x < 0.0f ? -1f : 1f;
							
						}
					}
				}
			}


			else
			{
				if ( coll.contacts[0].relativeVelocity.magnitude > 12f ) Damaged();
			}

		}



		public void SetupAISerum(PersonBehaviour person)
		{
			TargetPerson = person;

			if ( TargetPerson.IsAlive() )
			{
				BeenActivated = true;

				//	Already has AI
				if (TargetPerson.TryGetComponent<NpcBehaviour>( out NpcBehaviour npc)) { 
					AlreadyAI                = true;
					npc.DisableFlip          = true;
					person.OverridePoseIndex = (int)PoseState.WrithingInPain;
				}

			}

			

			AnimateRoutine = StartCoroutine(IAnimateAISerum());

			Timer1 = Time.time + 4;
		}

		public IEnumerator IAnimateAISerum()
		{
			

			for(;;)
			{
				yield return new WaitForFixedUpdate();
				
				if (Time.time > Timer1 )
                {

                    if ( !AlreadyAI )
                    {
						ModAPI.CreateParticleEffect("Flash", TargetPerson.Limbs[0].transform.position);
						audioSource.PlayOneShot(NpcMain.AudioSuccess, 1f);
                        NpcBehaviour npc = TargetPerson.transform.root.gameObject.GetOrAddComponent<NpcBehaviour>();
                        yield return new WaitForSeconds( 3 );
                        yield return new WaitForFixedUpdate();

                        npc.enabled = true;
                        npc.TeamId = TeamId;
                        npc.AIMethod = AIMethods.Syringe;
						StopAllCoroutines();
						Destroy( this );
                    } else
                    {
						NpcBehaviour npcx = TargetPerson.transform.root.gameObject.GetOrAddComponent<NpcBehaviour>();
						if (npcx.AIMethod == AIMethods.AIChip) npcx.StartCoroutine(npcx.IGlitch());
                    }
                    break;
                }


            }

            

		}
	}


	public class AISyringe : SyringeBehaviour
	{
		public override string GetLiquidID() => AISerum.ID;
		public class AISerum : Liquid
		{
			public const string ID = "AI SERUM";

			public AISerum()
			{
				Color = new UnityEngine.Color(0.733f, 0.211f, 0.027f);
			}

			public override void OnEnterLimb(LimbBehaviour limb)
			{
				NpcGadget gadget = limb.Person.gameObject.GetOrAddComponent<NpcGadget>();
				gadget.SetupAISerum(limb.Person);
			}

			public override void OnUpdate(BloodContainer container) {

			}
			public override void OnEnterContainer(BloodContainer container) {
					//var glow = ModAPI.CreateLight(container.transform, Color.red, 5, 1);
			}
			public override void OnExitContainer(BloodContainer container) {}
			
		}
	}
}
