﻿//                             ___           ___         ___     
//  Feel free to use and      /\  \         /\  \       /\__\    
//  modify any of this code   \:\  \       /::\  \     /:/  /    
//                             \:\  \     /:/\:\__\   /:/  /     
//   ________  ________    _____\:\  \   /:/ /:/  /  /:/  /  ___ 
//  |\   __  \|\   __  \  /::::::::\__\ /:/_/:/  /  /:/__/  /\__\
//  \ \  \|\  \ \  \|\  \ \:\~~\~~\/__/ \:\/:/  /   \:\  \ /:/  /
//   \ \   ____\ \   ____\ \:\  \        \::/__/     \:\  /:/  / 
//    \ \  \___|\ \  \___|  \:\  \        \:\  \      \:\/:/  /  
//     \ \__\    \ \__\      \:\__\        \:\__\      \::/  /   
//      \|__|     \|__|       \/__/         \/__/       \/__/     
//
//
using UnityEngine;
using System.Linq;
using System.Collections.Generic;
using System.Collections;

namespace PPnpc
{
    public class NpcRebirther : MonoBehaviour
    {
		public PhysicalBehaviour PB;
        public List<NpcBehaviour> NpcQueue;
		public GameObject TextObj;
        public TextMesh TextM;
		public SpriteRenderer[] SRS;
		public bool WorkingQueue = false;
		public Coroutine QueueRoutine = null;
		private bool _rebirtherActive = false;
		public SpawnableAsset asset;
		public GameObject RebirtherLight;
		public SingleFloodlightBehaviour[] Lightsx;
		private int _teamId = 0;
		public AudioClip[] AudioClips;
		public Color[] MiscColors;
		private AudioSource audioSource;
		public float[] MiscFloats;
		public string[] MiscStrings;
		public bool[] MiscBools;
		public Coroutine xCoroutine, AnimateRoutine;
		public NpcGadget Expansion;


		void Awake()
		{
			audioSource              = gameObject.AddComponent<AudioSource>();
			audioSource.spread       = 35f;
			audioSource.volume       = 1f;
			audioSource.minDistance  = 15f;
			audioSource.spatialBlend = 1f;
			audioSource.dopplerLevel = 0f;
		}

		public void SetupRebirther()
        {
			PB          = gameObject.GetComponent<PhysicalBehaviour>();
			MiscBools   = new bool[] { false, false };
			MiscStrings = new string[] {"000000", "000000"};
			MiscColors  = new Color[] { Color.red, Color.green, Color.blue };
			MiscFloats  = new float[]{ Time.time, 0.01f };
			TextObj     = new GameObject("SignText") as GameObject;

            TextObj.transform.SetParent(transform, false);
            TextObj.transform.parent   = transform;
            TextObj.transform.position = transform.position;

            TextObj.SetActive(true);

            TextM = TextObj.GetOrAddComponent<TextMesh>() as TextMesh;

            SpriteRenderer sr   = gameObject.GetComponent<SpriteRenderer>();
            MeshRenderer mr     = TextM.GetComponent<MeshRenderer>();
            mr.sortingLayerName = sr.sortingLayerName;
            mr.sortingOrder     = sr.sortingOrder + 1;

            TextM.transform.SetParent(transform, false);

            TextM.fontStyle = FontStyle.Normal;
            TextM.color     = Color.blue;
            TextM.anchor    = TextAnchor.UpperLeft;

            TextM.transform.localScale    = new Vector3(0.05f, 0.05f, 0.0f);
            TextM.transform.localPosition = new Vector3(-0.3f, 0.65f);
			TextM.alignment               = TextAlignment.Center;
			TextM.fontSize                = 18;

			NpcQueue = new List<NpcBehaviour>();

			


			//asset       = ModAPI.FindSpawnable("Red cathode light");
   //         instance	= UnityEngine.Object.Instantiate<GameObject>(asset.Prefab, transform.position, Quaternion.identity) as GameObject;
            
			//pb	= instance.GetComponent<PhysicalBehaviour>();
   //         pb.SpawnSpawnParticles                    = false;
			//pb.Disintegratable                        = false;
   //         pb.SimulateTemperature                    = false;
   //         pb.StabCausesWound                        = false;
   //         pb.Properties.Brittleness                 = 0.0001f;
   //         pb.Properties.BurningTemperatureThreshold = float.MaxValue;
   //         pb.Properties.Burnrate                    = 0.00001f;
   //         pb.Properties.Conducting                  = false;
   //         pb.Properties.Flammability                = 0.0000001f;
   //         pb.Properties.BulletSpeedAbsorptionPower  = float.MaxValue;

   //         instance.layer = 2;

   //         instance.transform.SetParent(gameObject.transform, false);
   //         instance.transform.position        = transform.position;
			//instance.transform.localPosition   = new Vector3(0,-1.5f);

			////instance.transform.localRotation	= new Quaternion(0,45,0,0);

			////instance.layer = LayerMask.NameToLayer("Debris"); 
			////pb.gameObject.layer = instance.layer;

			//FixedJoint2D joint2                 = instance.gameObject.AddComponent<FixedJoint2D>();
			//joint2.connectedBody                = PB.rigidbody;
			//joint2.autoConfigureConnectedAnchor = true;


			////instance.transform.localPosition = spotLight.Offset;
   //         //instance.transform.localRotation = Quaternion.Euler(0,0, spotLight.Rotation);

   //         if (instance.TryGetComponent<SpriteRenderer>(out SpriteRenderer srr2))
   //         {
   //             Texture2D tex     = new Texture2D(0, 0);
   //             Sprite mySprite   = Sprite.Create(tex, new Rect(0.0f, 0.0f, tex.width, tex.height), new Vector2(0.1f, 0.1f), 0.1f);
   //             srr2.sprite       = mySprite;
   //         }
            
   //         if (instance.TryGetComponent<GlowtubeBehaviour>(out GlowtubeBehaviour tube))
   //         {
   //             tube.Activated         = true;
   //             tube.LightSprite.color = Color.red;
			//	tube.GasColour         = Color.blue;
			//	tube.GasEffectRadius   = 5f;

   //             if (light.TryGetComponent<DamagableMachineryBehaviour>(out DamagableMachineryBehaviour dmb))
   //             {
   //                 GameObject.Destroy(dmb);
   //             }

			//}

			//GlowtubeBehaviour

			AnimateRoutine = StartCoroutine(IAnimateRebirther());
        }



		public bool RebirtherActive
        {
			get { return _rebirtherActive; }
			set { 
				if ( value != _rebirtherActive )
                {
					if (!value )
                    {
						if (QueueRoutine != null) StopCoroutine(QueueRoutine);
						foreach ( NpcBehaviour npc in NpcQueue )
                        {
							ModAPI.Notify("RUNNING QUEUE");
							if ( npc )
                            {
								GameObject.Destroy(npc.RebirthLight.gameObject);
								npc.RunLimbs(npc.LimbAlphaFull,true);
								npc.RunLimbs(npc.LimbGhost, false);
								npc.RunLimbs(npc.LimbImmune, false);
								npc.RunLimbs(npc.LimbIchi);
								NpcDeath reaper = npc.PBO.gameObject.AddComponent<NpcDeath>();
								reaper.Config(npc);
                            }
                        }
						NpcQueue.Clear();

						SingleFloodlightBehaviour[] lights = gameObject.GetComponentsInChildren<SingleFloodlightBehaviour>();

						for (int i = lights.Length; --i >= 0;) GameObject.Destroy(lights[i].gameObject);

                    } else
                    {
						_rebirtherActive = value; 
						//if (QueueRoutine != null) StopCoroutine(QueueRoutine);
						QueueRoutine = StartCoroutine(IProcessQueue());
                    }
                }
				_rebirtherActive = value; 
				
			}
        }


		public void Use(ActivationPropagation activation)
		{
			if (xCoroutine != null) StopCoroutine(xCoroutine);

			if (PB.charge < 1f) xCoroutine = StartCoroutine(INoPower());
			else
            {
				audioSource.PlayOneShot(AudioClips[0], 2f);
				TeamId += 1;
				string teamColor = xxx.GetTeamColor(TeamId);
				MiscStrings[0] = teamColor;
				MiscStrings[1] = teamColor;
            }
		}



		IEnumerator IProcessQueue()
        {
			//asset = ModAPI.FindSpawnable("Flashlight");
			//ModAPI.Notify("Process Queue");
   //         GameObject instance    = UnityEngine.Object.Instantiate<GameObject>(asset.Prefab, transform.position, Quaternion.identity) as GameObject;
   //         PhysicalBehaviour pb   = instance.GetComponent<PhysicalBehaviour>();

   //         pb.SpawnSpawnParticles                    = false;
			//pb.Disintegratable                        = false;
   //         pb.SimulateTemperature                    = false;
   //         pb.StabCausesWound                        = false;
   //         pb.Properties.Brittleness                 = 0.0001f;
   //         pb.Properties.BurningTemperatureThreshold = float.MaxValue;
   //         pb.Properties.Burnrate                    = 0.00001f;
   //         pb.Properties.Conducting                  = false;
   //         pb.Properties.Flammability                = 0.0000001f;
   //         pb.Properties.BulletSpeedAbsorptionPower  = float.MaxValue;

   //         instance.layer = 2;

   //         instance.transform.SetParent(gameObject.transform, false);
   //         instance.transform.position        = transform.position;
			//instance.transform.localPosition   = new Vector3(0,1.5f);
			
			
			//instance.transform.localScale = new Vector3(10f,1f);

			//instance.layer = LayerMask.NameToLayer("Debris"); 
			//pb.gameObject.layer = instance.layer;

			//FixedJoint2D joint                 = instance.gameObject.AddComponent<FixedJoint2D>();
			//joint.connectedBody                = PB.rigidbody;
			//joint.autoConfigureConnectedAnchor = true;

   //         Lightsx = new SingleFloodlightBehaviour[2];

			////instance.transform.localPosition = spotLight.Offset;
   //         //instance.transform.localRotation = Quaternion.Euler(0,0, spotLight.Rotation);

   //         if (instance.TryGetComponent<SpriteRenderer>(out SpriteRenderer srr))
   //         {
   //             Texture2D tex    = new Texture2D(0, 0);
   //             Sprite mySprite  = Sprite.Create(tex, new Rect(0.0f, 0.0f, tex.width, tex.height), new Vector2(0.1f, 0.1f), 0.1f);
   //             srr.sprite       = mySprite;
   //         }
            

			//Lightsx[0] = instance.GetComponent<SingleFloodlightBehaviour>();
			//Lightsx[0].transform.localScale = new Vector3(10f, 0.5f);
   //         Lightsx[0].Highlights[0].Intensity = 0f;
   //         Lightsx[0].Highlights[0].Colour = Color.red;
   //         Lightsx[0].Highlights[0].Initialise();
			//Lightsx[0].Activated = true;

   //         if (Lightsx[0].TryGetComponent<DamagableMachineryBehaviour>(out DamagableMachineryBehaviour dmb))
   //         {
   //             GameObject.Destroy(dmb);
   //         }

			float cpuSpeedStart = 10;
			float cpuSpeed;
			float ww;
			Vector2 dist;
			NpcBehaviour npc = null;
			while ( RebirtherActive )
            {
				ww = 1;
				cpuSpeed = Mathf.Clamp(cpuSpeedStart - (PB.charge * 0.1f), 1, 10);
				yield return new WaitForSeconds(cpuSpeed);

				if ( NpcQueue.Count <= 0 ) continue;
				Lightsx[0].Highlights[0].Colour = Color.red;
				//Lightsx[0].transform.localScale = new Vector3(, 0.5f);
				ModAPI.Notify("in the list");
				npc = NpcQueue[0];

				NpcQueue.RemoveAt(0);

				if (!npc) continue;

				npc.InRebirth = false;

				float sqr;

				while (npc && npc.PBO)
                {
					dist = (transform.position - npc.Head.position);
					sqr  = dist.sqrMagnitude;
                    npc.RB["UpperBody"].AddForce(dist.normalized * 30f * Time.fixedDeltaTime);
					if ( sqr < 2000f )
                    {
						Lightsx[0].Highlights[0].Intensity = 1f;
						Lightsx[0].transform.localScale = new Vector3(sqr/200f, 0.5f);
                    }
					if ( sqr < 5f )
                    {
						npc.RB["UpperBody"].velocity = Vector2.zero;
						break;
                    }
					yield return new WaitForFixedUpdate();
                }

				if (!npc) continue;

                npc.RB["UpperBody"].velocity = Vector2.zero;

				xxx.ToggleCollisions(npc.Head, transform);
				
				yield return new WaitForFixedUpdate();

				npc.RunLimbs(npc.LimbRecover);
				npc.RunLimbs(npc.LimbHeal);

                npc.LB["Foot"].PhysicalBehaviour.MakeWeightful();
				//npc.LB["FootFront"].PhysicalBehaviour.MakeWeightful();

				float timer = Time.time + 1.5f;
				Lightsx[0].Highlights[0].Colour = Color.green;
				while ( Time.time < timer )
                {
					ww += 0.05f;
					Lightsx[0].transform.localScale = new Vector3(Mathf.Clamp(ww,1,10), 0.5f);
					dist = (transform.position - npc.Head.position);
					npc.RB["Head"].AddForce(dist.normalized * 10f * Time.fixedDeltaTime);
                    npc.RB["UpperBody"].velocity *= 0.01f;
					yield return new WaitForFixedUpdate();
                }

				StartCoroutine(IMessage("You have been\nRebirthed!", 20));
				GameObject.Destroy(npc.RebirthLight.gameObject);

				for (int i = 1; ++i < 50;) 
				{
					dist = (transform.position - npc.Head.position);
					//npc.RB["Head"].AddForce(dist.normalized * 3f * Time.fixedDeltaTime);
                    npc.RB["UpperBody"].velocity *= 0f;
					npc.RunLimbs(npc.LimbAlphaDelta,0.05f);
					yield return new WaitForFixedUpdate();
					yield return new WaitForSeconds(0.05f);

					if (Time.frameCount % 1 == 0)
                    {
						LimbBehaviour limb = npc.PBO.Limbs.PickRandom();
						ModAPI.CreateParticleEffect("Flash", limb.transform.position);
                    }
				}

				npc.RunLimbs(npc.LimbGhost, false);
				npc.RunLimbs(npc.LimbAlphaFull,true);
				npc.RunLimbs(npc.LimbImmune, false);
				

				StartCoroutine(IMessage("Better luck\nthis time!", 24));

				npc.Reborn();
                
				Lightsx[0].Highlights[0].Intensity = 0f;

				Lightsx[0].Highlights[0].Colour = Color.red;



            }


			yield break;
        }
		public IEnumerator INoPower()
        {
			TextM.transform.localPosition = new Vector3(-0.3f, 0.65f);
			TextM.alignment               = TextAlignment.Center;
			TextM.fontSize                = 18;
			TextM.color                   = Color.blue;
			
			for ( int i = 0; ++i <= 10; )
            {
				TextM.text = "No Power";
				yield return new WaitForSeconds(0.5f);
				TextM.text = "";
				yield return new WaitForSeconds(0.5f);
            }
        }

		public IEnumerator IMessage(string message, int fontSize)
        {
			TextM.transform.localPosition = new Vector3(-0.3f, 0.65f);
			TextM.alignment               = TextAlignment.Center;
			TextM.fontSize                = fontSize;
			TextM.color                   = Color.cyan;
			TextM.text                    = message;
			yield return new WaitForSeconds(3);

			TextM.text = "";
        }

		public IEnumerator ILogo()
        {
			TextM.transform.localPosition = new Vector3(-0.3f, 0.65f);
			TextM.alignment = TextAlignment.Center;
			TextM.fontSize = 12;
			TextM.color = Color.yellow;
			
			for ( int i = 0; ++i <= 10; )
            {
				TextM.text = "Rebirther\n\n\"Giving dumb AI a 2nd \nchance since 2022!\"";
				yield return new WaitForSeconds(0.5f);
				
            }
			TextM.text = "";
        }
		public IEnumerator IAnimateRebirther()
		{
			GameObject bs;
			SpriteRenderer bsr;
			Color c;
			for(;;)
			{
				while ( PB.charge < 1f )
                {
                    SRS[1].color = new Color(0.0f,0.0f,0.0f,0.0f);
                    MiscBools[0] = MiscBools[1] = RebirtherActive = false;
					yield return new WaitForSeconds(2f);
                }

				if ( !MiscBools[0] )
                {
					RebirtherActive = false;
					if (xCoroutine != null) StopCoroutine(xCoroutine);
					TextM.text = "Booting Up...";
					TextM.color = Color.cyan;
					yield return new WaitForSeconds(2f);
					TextM.text = "";

					if ( !Expansion || !Expansion.MiscBools[0] )
                    {
                        MiscBools[0]    = MiscBools[1] = false;
						bs	            = new GameObject() as GameObject;
						bsr				= bs.AddComponent<SpriteRenderer>();
						bsr.sprite      = NpcMain.BlueScreenOfDeath;
						bs.transform.SetParent(transform);
						bs.transform.position      = transform.position;
						bs.transform.rotation      = transform.rotation;
						bs.transform.localPosition = new Vector2(0,0.5f);
						

						while ( PB.charge > 1f )
                        {
							yield return new WaitForFixedUpdate();
                        }

						GameObject.Destroy(bs);
                    } else
                    {
	                    MiscBools[0] = true;
						SRS[1].color = new Color(1.0f,1.0f,1.0f,0.1f);
						TeamId = TeamId;
						MiscFloats[1] = 0.01f;
						StartCoroutine(ILogo());
                    }
                }

				if ( MiscBools[0] )
                {
					if ( !Expansion || !Expansion.MiscBools[0] )
                    {
						RebirtherActive = false;
                        MiscBools[0]    = MiscBools[1] = false;
						bs	            = new GameObject() as GameObject;
						bsr				= bs.AddComponent<SpriteRenderer>();
						bsr.sprite      = NpcMain.BlueScreenOfDeath;
						bs.transform.SetParent(transform);
						bs.transform.position      = transform.position;
						bs.transform.rotation      = transform.rotation;
						bs.transform.localPosition = new Vector2(0,0.5f);
						SRS[1].color = new Color(0.0f,0.0f,0.0f,1f);

						while ( PB.charge > 1f )
                        {
							yield return new WaitForFixedUpdate();
                        }

						GameObject.Destroy(bs);
                    } else
                    {
						RebirtherActive = true;
						if (TeamId == 0) { 
							if ( Time.frameCount % 10 == 0 )
							{
								MiscFloats[1] = Mathf.Clamp(PB.charge * 0.5f, 25.1f, 100) * 0.01f;
							}
							SRS[1].color = Color.HSVToRGB( Mathf.PingPong((Time.time + MiscFloats[0]) * 0.1f, 1), MiscFloats[1] * 2, MiscFloats[1]);

							//Lights[1].Color = Color.HSVToRGB( Mathf.PingPong((Time.time + MiscFloats[0]), 1), 1, 1);
						} else
						{
							SRS[1].color = Color.Lerp(MiscColors[0], MiscColors[1], Mathf.PingPong((Time.time + MiscFloats[0]) , 1));
						}

						if (NpcQueue.Count > 0) {
							c = Color.HSVToRGB( Mathf.PingPong((Time.time + MiscFloats[0]) * 0.1f, 1), 1, 1);
							for(int i = NpcQueue.Count; --i >= 0;) {
								if ( !NpcQueue[i] || !NpcQueue[i].RebirthLight || !NpcQueue[i].RebirthLight.gameObject) continue;
								NpcQueue[i].RebirthLight.Color = c;
							}

                            if ( Time.frameCount % 100 == 0 )
                            {
                                NpcBehaviour npc = NpcQueue.PickRandom();

                                if (npc) npc.RB["UpperBody"].AddForce( UnityEngine.Random.insideUnitCircle * xxx.rr( 1, PB.charge / 3 ), ForceMode2D.Impulse );
                            }

                        }

					}
                }



				
				yield return new WaitForFixedUpdate();
			}
		}

		public int TeamId { 
			get { 
				return Mathf.Clamp(_teamId, 0, NpcGlobal.MaxTeamId); 
				} 
			set { 
				if (value > NpcGlobal.MaxTeamId) value = 0; 
				_teamId = value;
				if (_teamId > 0)
				{
					string teamColor = xxx.GetTeamColor(_teamId);
					
					
					string hexalpha = Mathf.RoundToInt(Mathf.Clamp(PB.charge * 2, 25, 255)).ToString("X2");
					if (ColorUtility.TryParseHtmlString(teamColor + hexalpha, out Color color))  MiscColors[0] = color;
					hexalpha = Mathf.RoundToInt(Mathf.Clamp(PB.charge , 15, 125)).ToString("X2");
					if (ColorUtility.TryParseHtmlString(teamColor + hexalpha, out Color color2)) MiscColors[1] = color2;

					//xxx.CheckRebirthers();

				}
			} 
		}
    }
}
